
library("glmnet");library(qgraph);library(matrixStats)

Yeast10 <- read_csv("Desktop/Non_linear_network/Yeast10.txt", col_names = TRUE)
trueYeast10 <- read_table2("Desktop/Non_linear_network/trueYeast10.txt",  col_names = FALSE)
testi <- as.matrix(Yeast10)
lin_graph <- matrix(0, ncol(testi), ncol(testi))
nonlin_graph <- matrix(0, ncol(testi), ncol(testi))
residualtesti <- matrix(0,nrow(testi), ncol(testi))
colnames(testi) <- as.character(c("G1","G2","G3","G4","G5","G6","G7","G8","G9","G10"))
colnames(trueYeast10) <- as.character(c("G1","G2","G3","G4","G5","G6","G7","G8","G9","G10"))

titlevec <- as.character(c("Network A (TPR = 1.0) ","Network B (TPR = 0.8) ","Network C (TPR = 0.4)","Network D (TPR = 0.2)","Network E (1.15)","Network F (1.25)","Network G (1.35)"))

par(mfrow=c(1,5))
qgraph(trueYeast10, layout="circle")
title("The true network",line=-2,cex.main=1.2)
lamb= c(1.25,1.35,1.40,1.55)
for(k in 1:length(lamb)){
  a <- lamb[k]
for(i in 1:ncol(testi)){
  
  ########lineaarinen osuus######################glmnet#
  ########haetaan lambda
  fit=glmnet(scale(testi[,-i]), scale(testi[,i]), alpha = 1/3, maxit = 10000)
  ##########valitaan pienimm?n virheen mukaan lambda###########
  Coefficients <- coef(fit, s = a)
  lin_graph[,i] <- append(as.vector(Coefficients[-1]), 0, after = i-1)
  v <- testi[,-i] %*% as.vector(Coefficients[-1])
  residualtesti[,i] <- testi[,i] - v
}
for(i in 1:10){
  for(j in 1:10){
    lin_graph[i,j] <- max(abs(lin_graph[i,j]),abs(lin_graph[j,i]))
  }
}  
  
  lin_graph[lower.tri(lin_graph)] <- 0
  
lin_graph[which(lin_graph != 0)] <- -1


for(i in 1:ncol(testi)){
  
  
  uusivaste <- residualtesti[,i] 
  settesti <- testi[,-i]
  
  #######################Only Nonlinear GRN estimation #############################
  
  uusi <- cbind(scale(uusivaste),scale(settesti))
  uusi <- uusi[order(uusi[,1]),]
  foo <- t(uusi)
  cols <- combn( ncol(foo), 2)
  tripleSums <- apply( cols, 2, function(z) rowDiffs(foo[,z]))
  uusi <- t(tripleSums)
  HEpheno2 <- uusi[,1]
  HEtesti <- uusi[,-1]
  v1 <- (abs(HEtesti))^0.2
  ##############Cross-validation step // optional ###############
  # cv.fit3=cv.glmnet(v1, scale(log(HEpheno2^2)), alpha = 1.0, maxit = 10000)
  
  cv.fit3=cv.glmnet(v1, log((HEpheno2)^2), alpha = 1, maxit = 10000)
  
  fit3=glmnet(v1, log((HEpheno2)^2), alpha = 1, maxit = 10000)
  
  #uusi vaihe, antaa noin kaksi tuhat geeni? ulos
  Bandwidth <- (abs(coef(fit3, s = a))[-1])
  
  
  
  Bandwidth<- append(Bandwidth, 0, after = i-1)
  
  nonlin_graph[,i] <- Bandwidth
  #matList_SNS[[l]] <- as .matrix(matList_SNS[[l]])
  #matList_SNS[[l]][,i] <- Bandwidth
  
  
  
}

for(i in 1:10){
  for(j in 1:10){
    nonlin_graph[i,j] <- max(abs(nonlin_graph[i,j]),abs(nonlin_graph[j,i]))
  }
}  

nonlin_graph[lower.tri(nonlin_graph)] <- 0

nonlin_graph[which(nonlin_graph != 0)] <- 1
combined <- abs(lin_graph)+abs(nonlin_graph)

#The following implies that if the effect is deemed to be both linear and non-linear, the edge in the final network is set to be linear.  

for(i in 1:10){
  for(j in 1:10){
    if(lin_graph[i,j] !=0){
      combined[i,j] <- -1
    }
  }
}  
colnames(combined) <- as.character(c("G1","G2","G3","G4","G5","G6","G7","G8","G9","G10"))


qgraph(combined,layout="circle")
x <- c(print(length(which(combined != 0))),titlevec[k])
title(titlevec[k],line=-2,cex.main=1.2)

}

