library("glmnet")
library("matrixStats")
library("qgraph")
library("minet")
library("energy")
library("minet")
library("snowfall")


rdata <- read.csv("rr.csv", header = TRUE)
testi <- rdata[,c(42:272)];dat <- testi;data <- testi

#k is number of replicated

k <- 10
genereps <- rep(list(matrix(NA, nrow(testi), ncol(testi)+5)), k)
SNSlist <- rep(list(matrix(NA, ncol(testi)+5, ncol(testi)+5)), k)
her1 <- rep(0,k)
her2 <- rep(0,k)
her3 <- rep(0,k)
her4 <- rep(0,k)
her5 <- rep(0,k)

SNSauc <- rep(0,k)
mimrAUC<- rep(0,k)
miclrAUC<- rep(0,k)
mirelAUC<- rep(0,k)


dcmrAUC<- rep(0,k)
dcclrAUC<- rep(0,k)
dcrelAUC<- rep(0,k)




for(l in 1:k){
  
  
  
  #Simulate new variables with nonlinear connections: quadratic, cosine, cubic and interaction term
  
  
  x1 <- data[,15]+data[,47]^2 +rnorm(nrow(testi),0,1.0)
  
  x2 <- data[,5]+cos(data[,100]) +rnorm(nrow(testi),0,0.6)
  
  x3 <- data[,35]+data[,40]+data[,50]+data[,8]*data[,150]*data[,220] +rnorm(nrow(testi),0,0.6)
  
  x4 <- data[,30]+data[,200]^3 +rnorm(nrow(testi),0,3.0)
  
  x5 <- data[,25]+data[,80]*data[,110] +rnorm(nrow(testi),0,1.5)
  
  
  testi <- cbind(x1,x2,x3,x4,x5,data)
  genereps[[l]] <- testi
  
  #########Heritabilities########
  
  her1[l] <- (var(x1)-1.0^2)/(var(x1))
  her1[l] <- (var(x2)-0.6^2)/(var(x2))    
  her1[l] <-  (var(x3)-1.0^2)/(var(x3))
  her1[l] <- (var(x4)-3.0^2)/(var(x4))
  her1[l] <-  (var(x5)-1.5^2)/(var(x5))
  
  
  ##TRUE MATRIX FOR ROC-CURVES##
  
  ROCmatrix <- matrix(0,ncol(testi), ncol(testi))
  
  ROCmatrix[1,52] <- 1
  ROCmatrix[2,105] <- 1
  ROCmatrix[3,155]<- 1
  ROCmatrix[3,13]<- 1
  ROCmatrix[3,225]<- 1
  ROCmatrix[4,205]<- 1
  ROCmatrix[5,85]<- 1
  ROCmatrix[5,115]<- 1
  
  true <- as.matrix(ROCmatrix)
  
  ##tyhj?t verkkomatriisit######
  lin_graph <- matrix(0, ncol(testi), ncol(testi))
  nonlin_graph <- matrix(0, ncol(testi), ncol(testi))
  
  
  ############RESIDUAALI-NOODIT#########
  residualtesti <- matrix(0,nrow(testi), ncol(testi))
  
  testi <- as.matrix(testi)
  for(i in 1:ncol(testi)){
    
    ########lineaarinen osuus######################glmnet#
    ########haetaan lambda
    cv.fit = cv.glmnet(testi[,-i], testi[,i], alpha = 1/3, maxit = 10000)
    fit=glmnet(testi[,-i], testi[,i], alpha = 1/3, maxit = 10000)
    ##########valitaan pienimm?n virheen mukaan lambda###########
    Coefficients <- coef(fit, s = cv.fit$lambda.min)
    
    v <- testi[,-i] %*% as.vector(Coefficients[-1])
    residualtesti[,i] <- testi[,i] - v
  }
  
  ##########SNS-method#########3
  
  for(i in 1:ncol(testi)){
    
    ######################Nonlinear GRN estimation #############################
    uusi <- cbind(residualtesti[,i],testi[,-i])
    uusi <- uusi[order(uusi[,1]),]
    foo <- t(uusi)
    cols <- combn( ncol(foo), 2)
    tripleSums <- apply( cols, 2, function(z) rowDiffs(foo[,z]))
    uusi <- t(tripleSums)
    HEpheno2 <- uusi[,1]
    HEtesti <- uusi[,-1]
    v1 <- (abs(HEtesti))^0.2
    ##############Cross-validation step // optional ###############
    cv.fit3=cv.glmnet(v1, scale(log(HEpheno2^2)), alpha = 1.0, maxit = 10000)
    
    #cv.fit3=cv.glmnet(v1, scale(log(HEpheno2^2)), alpha = 1/3, maxit = 10000)
    
    fit3=glmnet(v1, scale(log(HEpheno2^2)), alpha = 1, maxit = 10000)
    
    
    #uusi vaihe, antaa noin kaksi tuhat geeni? ulos
    Bandwidth <- (abs(coef(fit3, s = cv.fit3$lambda.min))[-1])
    
    Bandwidth<- append(Bandwidth, 0, after = i-1)
    
    nonlin_graph[,i] <- Bandwidth
    #matList_SNS[[l]] <- as.matrix(matList_SNS[[l]])
    #matList_SNS[[l]][,i] <- Bandwidth
    
    
    
  }
  nonlin_graph <- t(nonlin_graph)
  SNSlist[[l]] <-  nonlin_graph
  nonlin_graph[lower.tri(nonlin_graph)] <- 0
  SNS.tbl<-validate(nonlin_graph,true)
  
  SNSauc[l] <- auc.roc(SNS.tbl)
}

DCmrlist <- rep(list(matrix(NA, ncol(testi)+5, ncol(testi)+5)), k)
DCclrist <- rep(list(matrix(NA, ncol(testi)+5, ncol(testi)+5)), k)
DCrellist <- rep(list(matrix(NA, ncol(testi)+5, ncol(testi)+5)), k)

MImrlist <- rep(list(matrix(NA, ncol(testi)+5, ncol(testi)+5)), k)
MIrellist <- rep(list(matrix(NA, ncol(testi)+5, ncol(testi)+5)), k)
MIclrist <- rep(list(matrix(NA, ncol(testi)+5, ncol(testi)+5)), k)
############DC-BASED METHOD#########

for(l in 1:10){
  
  dat <- genereps[[l]]
  #p stand for the number of genes
  p<-ncol(dat)
  
  #compute distance correlations for each pair of genes
  #optional: use snowfall package for parallel computing if the gene expression file is big
  
  sfExport("dat")
  sfExport("p")
  
  dcor2<-function(i){
    dis<-matrix(0,ncol=p)
    for(j in (i+1):p){
      dis[j]<-dcor(dat[,i],dat[,j])
    }
    return(dis)
  }
  
  res<-sfSapply(1:(p-1),dcor2)
  res<-cbind(res,rep(0,p))
  res<-res+t(res)
  
  
  #######################
  
  DCmrlist[[l]] <- mrnet(res)
  DCclrist[[l]] <- clr(res)
  DCrellist[[l]] <- res
  
  
  mrDC<-mrnet(res)
  clrDC<-clr(res)
  relDC <- res
  
  mrDC[lower.tri(mrDC)] <- 0
  clrDC[lower.tri(clrDC)] <- 0
  relDC[lower.tri(relDC)] <- 0
  
  
  dcmr.tbl<-validate(mrDC,true)
  dcclr.tbl<-validate(clrDC,true)
  dcrel.tbl<-validate(relDC,true)
  
  dcmrAUC[l] <- auc.roc(dcmr.tbl)
  dcclrAUC[l] <- auc.roc(dcclr.tbl)
  dcrelAUC[l] <- auc.roc(dcrel.tbl)
  
  
  
  ########MI-based approach#########
  #read the gene expression and compute MI between each pair of genes
  
  MI<-build.mim(dat,"mi.shrink","equalwidth",sqrt(nrow(dat)))
  
  MImrlist[[l]] <- mrnet(MI)
  MIclrist[[l]] <- clr(MI)
  MIrellist[[l]]<-  MI
  
  mrMI<-mrnet(MI)
  clrMI<-clr(MI)
  relMI <- MI
  
  mrMI[lower.tri(mrMI)] <- 0
  clrMI[lower.tri(clrMI)] <- 0
  relMI[lower.tri(relMI)] <- 0
  
  
  mimr.tbl<-validate(mrMI,true)
  miclr.tbl<-validate(clrMI,true)
  mirel.tbl<-validate(relMI,true)
  
  mimrAUC[l] <- auc.roc(mimr.tbl)
  miclrAUC[l] <- auc.roc(miclr.tbl)
  mirelAUC[l] <- auc.roc(mirel.tbl)
  
}








SNSpr <- rep(0,k)

mimrpr<- rep(0,k)
miclrpr<- rep(0,k)
mirelpr<- rep(0,k)


dcmrpr<- rep(0,k)
dcclrpr<- rep(0,k)
dcrelpr<- rep(0,k)





for(l in 1:k){
  
  nonlin_graph <- SNSlist[[l]] 
  nonlin_graph[lower.tri(nonlin_graph)] <- 0
  SNSpr[l] <- roc(as.vector(ROCmatrix),as.vector(nonlin_graph), partial.auc = c(0.9,1.0), partial.auc.correct = TRUE)$auc
  
  
  
  
  mrMI<-MImrlist[[l]]
  clrMI<-MIclrist[[l]]
  relMI <- MIrellist[[l]]
  
  mrMI[lower.tri(mrMI)] <- 0
  clrMI[lower.tri(clrMI)] <- 0
  relMI[lower.tri(relMI)] <- 0
  
  
  mimrpr[l] <- roc(as.vector(ROCmatrix),as.vector(mrMI), partial.auc = c(0.9,1.0), partial.auc.correct = TRUE)$auc
  miclrpr[l] <- roc(as.vector(ROCmatrix),as.vector(clrMI), partial.auc = c(0.9,1.0), partial.auc.correct = TRUE)$auc
  mirelpr[l] <- roc(as.vector(ROCmatrix),as.vector(relMI), partial.auc = c(0.9,1.0), partial.auc.correct = TRUE)$auc
  
  
  ########################################
  
  mrDC <- DCmrlist[[l]]
  clrDC  <- DCclrist[[l]]
  relDC <- DCrellist[[l]] 
  
  
  
  mrDC[lower.tri(mrDC)] <- 0
  clrDC[lower.tri(clrDC)] <- 0
  relDC[lower.tri(relDC)] <- 0
  
  dcmrpr[l] <-  roc(as.vector(ROCmatrix),as.vector(mrDC), partial.auc = c(0.9,1.0), partial.auc.correct = TRUE)$auc
  dcclrpr[l] <- roc(as.vector(ROCmatrix),as.vector(clrDC), partial.auc = c(0.9,1.0), partial.auc.correct = TRUE)$auc
  dcrelpr[l] <- roc(as.vector(ROCmatrix),as.vector(relDC), partial.auc = c(0.9,1.0), partial.auc.correct = TRUE)$auc
  
  
  ########################################
  
  
  
  
}

mean(SNSpr)

 mean(mimrpr)

 mean(miclrpr)

 mean(mirelpr)

 mean(dcmrpr)

 mean(dcclrpr)

 mean(dcrelpr)





for(l in 1:k){
  
  her1[l] <- (var(genereps[[l]][,1])-1.0^2)/(var(genereps[[l]][,1]))
  her2[l] <- (var(genereps[[l]][,2])-0.6^2)/(var(genereps[[l]][,2]))    
  her3[l] <-  (var(genereps[[l]][,3])-0.6^2)/(var(genereps[[l]][,3]))
  her4[l] <- (var(genereps[[l]][,4])-3.0^2)/(var(genereps[[l]][,4]))
  her5[l] <-  (var(genereps[[l]][,5])-1.5^2)/(var(genereps[[l]][,5]))
  
}

mean(her1)
mean(her2)
mean(her3)
mean(her4)
mean(her5)
