library("glmnet")
library("matrixStats")
library("qgraph")
library("minet")
library("energy")
library("minet")
library("snowfall")
library("pROC")



rdata <- read.csv("rr.csv", header = TRUE)
testi <- rdata[,c(42:272)];dat <- testi;data <- testi

#k is number of replicated

k <- 10



full_SNSauc<- rep(0,k)
restricted_0.10_SNSauc<- rep(0,k)
restricted_0.40_SNSauc<- rep(0,k)


alpha1= 1/3
alpha2= 2/3
gamma = 0.2

######

for(l in 1:k){
  
  
  testi <- genereps[[l]]
  
  ##TRUE MATRIX FOR ROC-CURVES##
  
  ROCmatrix <- matrix(0,ncol(testi), ncol(testi))
  
  ROCmatrix[1,52] <- 1
  ROCmatrix[2,105] <- 1
  ROCmatrix[3,155]<- 1
  ROCmatrix[3,13]<- 1
  ROCmatrix[3,225]<- 1
  ROCmatrix[4,205]<- 1
  ROCmatrix[5,85]<- 1
  ROCmatrix[5,115]<- 1
  
  true <- as.matrix(ROCmatrix)
  
  ##tyhj?t verkkomatriisit######
  lin_graph <- matrix(0, ncol(testi), ncol(testi))
  nonlin_graph <- matrix(0, ncol(testi), ncol(testi))
  
  
  ############RESIDUAALI-NOODIT#########
  residualtesti <- matrix(0,nrow(testi), ncol(testi))
  
  testi <- as.matrix(testi)
  for(i in 1:5){
    
    ########lineaarinen osuus######################glmnet#
    ########haetaan lambda
    cv.fit = cv.glmnet(testi[,-i], testi[,i], alpha = alpha1, maxit = 10000)
    fit=glmnet(testi[,-i], testi[,i], alpha = alpha1, maxit = 10000)
    ##########valitaan pienimm?n virheen mukaan lambda###########
    Coefficients <- coef(fit, s = cv.fit$lambda.min)
    
    v <- testi[,-i] %*% as.vector(Coefficients[-1])
    residualtesti[,i] <- testi[,i] - v
  }
  
  ##########SNS-method#########3
  
  for(i in 1:5){
    
    ######################Nonlinear GRN estimation #############################
    uusi <- cbind(residualtesti[,i],testi[,-i])
    uusi <- uusi[order(uusi[,1]),]
    foo <- t(uusi)
    cols <- combn( ncol(foo), 2)
    tripleSums <- apply( cols, 2, function(z) rowDiffs(foo[,z]))
    uusi <- t(tripleSums)
    HEpheno2 <- uusi[,1]
    HEtesti <- uusi[,-1]
    v1 <- (abs(HEtesti))^gamma
    ##############Cross-validation step // optional ###############
    cv.fit3=cv.glmnet(v1, scale(log(HEpheno2^2)), alpha = alpha2, maxit = 10000)
    
    #cv.fit3=cv.glmnet(v1, scale(log(HEpheno2^2)), alpha = 1/3, maxit = 10000)
    
    fit3=glmnet(v1, scale(log(HEpheno2^2)), alpha = alpha2, maxit = 10000)
    
    
    #uusi vaihe, antaa noin kaksi tuhat geeni? ulos
    Bandwidth <- (abs(coef(fit3, s = cv.fit3$lambda.min))[-1])
    
    Bandwidth<- append(Bandwidth, 0, after = i-1)
    
    nonlin_graph[,i] <- Bandwidth
    #matList_SNS[[l]] <- as.matrix(matList_SNS[[l]])
    #matList_SNS[[l]][,i] <- Bandwidth
    
    
    
  }
  
  
  nonlin_graph <- t(nonlin_graph)
  nonlin_graph[lower.tri(nonlin_graph)] <- 0
  
  full_SNSauc[l] <- roc(as.vector(true[1:5,]),as.vector(nonlin_graph[1:5,]))$auc
  restricted_0.10_SNSauc[l] <- roc(as.vector(true[1:5,]),as.vector(nonlin_graph[1:5,]), partial.auc = c(0.9,1.0), partial.auc.correct = TRUE)$auc
  restricted_0.40_SNSauc[l] <- roc(as.vector(true[1:5,]),as.vector(nonlin_graph[1:5,]), partial.auc = c(0.6,1.0), partial.auc.correct = TRUE)$auc
  
  
  
}


mean(full_SNSauc)
mean(restricted_0.10_SNSauc)
mean(restricted_0.40_SNSauc)

alpha_0.33_0.66_full_SNSauc <- full_SNSauc
alpha_0.33_0.66_restricted_0.10_SNSauc <- restricted_0.10_SNSauc
alpha_0.33_0.66_restricted_0.40_SNSauc <- restricted_0.40_SNSauc

save(alpha_0.33_0.66_full_SNSauc, file = "alpha_0.33_0.66_full_SNSauc.Rdata")
save(alpha_0.33_0.66_restricted_0.10_SNSauc, file = "alpha_0.33_0.66_restricted_0.10_SNSauc.Rdata")
save(alpha_0.33_0.66_restricted_0.40_SNSauc, file = "alpha_0.33_0.66_restricted_0.40_SNSauc.Rdata")



